#!/usr/bin/perl
#
#	Script para a execucao do daemon swdkbd.
#

use strict;

my $DAEMON="/usr/sbin/swdkbd";
my $whoami=`whoami`;
chomp $whoami;
if($whoami !~ /^root$/)
{
	warn "E necessario ser root para rodar este programa!\n";
	exit 1;
}
if (not -f $DAEMON){
	warn "Impossivel encontrar $DAEMON";
	exit 1;
}

my $param = shift;
my $param_ok = "no";
foreach ($param){
	/^start$/ && do{$param_ok = "sim";&start();last};
	/^stop$/ && do{$param_ok = "sim";&stop();last};
	/^restart|force-reload$/ && do{$param_ok = "sim";&stop();&start();last};	
	/^reload$/ && do{$param_ok = "sim";&reload();last};
}

if($param_ok eq "no") { 
	warn "Uso: /etc/init.d/swdkbd {start|stop|reload|restart|force-reload}\n";
	exit 1;
}

sub test_running{
	my @pslines = `ps aux | grep swdkbd | grep -v grep`;
	foreach my $psline (@pslines){
		chomp;
		return 0 if not $psline;
		my @proc_data = split /\s+/, $psline;
		if($proc_data[10] =~ /\/swdkbd$/)
		{
			my $pidn = $proc_data[1];
			if($pidn != $$){
				print "Processo swdkbd ($pidn) esta rodando.\n";
				return $pidn;
			}
		}
	}
	return 0;
}

sub start{
	my $pid = &test_running();
	exit 0 if $pid;
	system("$DAEMON -f &");
	print "Iniciando $DAEMON...\n";
}

sub stop{
	my $pid = &test_running();
	if($pid) { print "Terminando o processo...\n"; kill 15,$pid;}
	else	 { print "O processo nao esta rodando (swdkbd)!\n";}
}

sub reload{
	my $pid = &test_running();
	if($pid) { 
		print "Enviando sinal SIGHUP (1) para swdkbd($pid).\n";
		kill 1, $pid;
	}else{ print "O processo nao esta rodando (swdkbd)!\n"; &start()}
}
